//ESTE PROGRAMA USA EL COMPILADOR CCS. LLEVA LAS DIRECTIVAS
//NECESARIAS PARA FUNCIONAR CON EL SOFTWARE "TINY"
//DEBE PROGRAMARSE LA MEMORIA FLASH DEL 16F88 A TRAVES 
//DEL PUERTO SERIAL CON ESE SOFTWARE. 
//EL PROGRAMA FUNCIONA EN EL SISTEMA "PICCITO" Y TIENE
//COMO APLICACION UN CONTROL DE SEMAFORO CON 3 FOCOS
//DE 40 WATTS (VER PROYECTO)
//PUEDE OPERAR EN MODO LOCAL O EN MODO REMOTO.

//EL PROGRAMA DEBE INICIAR EN LA DIRECCION 3. USE LAS DIRECTIVAS
//#rom 0X0000={0X018A,0X2803}	//DATOS REQUERIDOS POR TINY					
//#built(reset=0x0003)

//DESPUES DE RESET:
//ENTRA EN MODO REMOTO CON EL PUERTO SERIAL A 9600 BPS
//DESPUES DE RESET, ESPERAR 2 SEGUNDOS PARA EL INICIO
//ENVIA "0K>" A COMPUTADORA PC Y RECIBE UN COMANDO DE PC:
//L =PASA A MODO LOCAL (ACTIVA Y DESACTIVA LOS FOCOS
//SEGUN LOS TIEMPOS ENVIADOS PREVIAMENTE POR EL USUARIO)
//S =ENVIA EL VALOR DE LA DIRECCION DE LA UTR (MICROSWITCHES)
//V1=ENCIENDE,V0=APAGA LED VERDE, ENVIA ECO Y "OK>"
//A1=ENCIENDE,A0=APAGA LED AMARILLO, ENVIA ECO Y "OK>"
//R1=ENCIENDE,R0=APAGA LED ROJO, ENVIA ECO Y "OK>"
//T = ENVIA "VERDE=",AMARILLO=","ROJO="
//EL USUARIO DEBE ESCRIBIR EN SEGUNDOS, (MAXIMO 255)
//EL TIEMPO ASIGNADO PARA CADA FOCO, SEGUIDO DE "CR"
//GUARDA ESTOS DATOS EN EEPROM
//Y DESPUES PASA A MODO LOCAL Y ACTIVA Y DESACTIVA LOS FOCOS
//SEGUN LOS TIEMPOS ENVIADOS PREVIAMENTE POR EL USUARIO.
//CON EL COMANDO "W", PASA A MODO REMOTO,
//APAGA TODOS LOS FOCOS, Y ENVIA "OK>"




#if defined(__PCM__)
#include "16F88.h"
#use delay(clock=4000000)
#include <stdlib.h> //funcin atol()
#use rs232(baud=9600,xmit=PIN_B5,rcv=PIN_B2)

#rom 0X0000={0X018A,0X2803}	//DATOS REQUERIDOS POR TINY					
#build(reset=0x0003)

char timed_getc();				
retraso(int a);
char x;
main(void){
char a,b;
char array[10];
int VERDE,AMARILLO,ROJO,S;

TRISA=0;				//PUERTO A SALIDAS
TRISB=0XFF;				//PUERTO B ENTRADAS
PORTA=0;				//PUERTO A=0
RBPU=0;					//PULL UPS ACTIVOS EN PUERTO B
remoto:

{
printf("\r\n");
while(1){
printf("OK>");
a=getchar();
putchar(a);
if(a=='V'){b=getchar();
			putchar(b);
			if (b=='0'){RA0=0;}
			if (b=='1'){RA0=1;}
			}
if(a=='A'){b=getchar();
			putchar(b);
			if (b=='0'){RA1=0;}
			if (b=='1'){RA1=1;}
			}
if(a=='R'){b=getchar();
			putchar(b);
			if (b=='0'){RA2=0;}
			if (b=='1'){RA2=1;}
			}
if(a=='L')goto local;
if(a=='T')goto tiempos;
if(a=='S')
{S=(RB0+(RB1*2)+(RB3*4)+(RB4*8));
printf("\r\nDIRECCION=%d",S);}
printf("\r\n");}
}
tiempos:
printf("\r\nVERDE=");
for(a=0;a<5;a++)
{array[a]=getchar();
if (array[a]==13)goto wo;
putchar(array[a]);}
wo:array[a]=0;			//caracter null
VERDE=atoi(array);		//convierte a long int
printf("\r\n%u SEGUNDOS",VERDE);

printf("\r\nAMARILLO=");
for(a=0;a<5;a++)
{array[a]=getchar();
if (array[a]==13)goto wi;
putchar(array[a]);}
wi:array[a]=0;			//caracter null
AMARILLO=atoi(array);		//convierte a long int
printf("\r\n%u SEGUNDOS",AMARILLO);

printf("\r\nROJO=");
for(a=0;a<5;a++)
{array[a]=getchar();
if (array[a]==13)goto we;
putchar(array[a]);}
we:array[a]=0;			//caracter null
ROJO=atoi(array);		//convierte a long int
printf("\r\n%u SEGUNDOS",ROJO);
						//GUARDA INFORMACION EN EEPROM
write_eeprom(0,VERDE);
write_eeprom(1,AMARILLO);
write_eeprom(2,ROJO);

local:
x=0;
VERDE=read_eeprom(0);
AMARILLO=read_eeprom(1);
ROJO=read_eeprom(2);
WHILE(1){
RA0=1;
retraso(VERDE);
RA0=0;
if(x==5)goto remoto;
RA1=1;
retraso(AMARILLO);
RA1=0;
if(x==5)goto remoto;
RA2=1;
retraso(ROJO);
RA2=0;
if(x==5)goto remoto;
}

}
retraso(int a)
{
int b,c;
//ESTA SECCION DEL PROGRAMA PERMITE INTERUMPIR EL MODO
//LOCAL Y PASAR A MODO REMOTO ENVIANDO LA "W".
for(b=0;b<a;b++)
{
timed_getc();
if(timed_getc()=='W')
{x=5;return;}	

}
}
//ESTA FUNCION ESPERA UN CARACTER DEL PUERTO SERIAL
//DURANTE 1 SEGUNDO Y REGRESA.
char timed_getc() 
{
long timeout;
timeout=0;
while(!kbhit()&&(++timeout<21000))   // 1 segundo
delay_us(10);
if(kbhit())
return(getc());
else {   
return(0);
}

}

 



